#ifndef __SDSPI__H
#define __SDSPI__H
#include <STC12C5A60S2.H>
/******************************************************************************************************
1:	Ҫ
	λ
	ʼ
	д
	

2:	SD6ֽ

		ֽ1		2-5ֽ				6ֽ(ܹ48λ)
		01()+		λǰ	CRC + 1
	
	Ӧ	
		R1R3R6ӦΪ48λR2ӦΪ136λCID/CSD128λ
		00()+  (ܹ48λ)(136λ)+ 1(ĩλ1)	
****************************************************************************************************************
Ĵ
	   *1CID	 128bit		ʶĴ
		2RCA	 16bit		ԿַĴ*SPIģʽû
	   *3CSD   128bit		ĴSDС
		4SCR   64bit		üĴ
	   *5OCR	32bit		ĴĵѹǷǸĿ
		
*******************************************************************************************************	
1:	飺	CMD17ָȴR1ӦȴSD0xfeӦ.֮512ֽڣֹƬѡ8ʱӽա

2	飺    CMD18ָȴR1ӦȴSD0xfeӦ.֮512ֽڣȴSD0xfeӦ.֮512ֽڣ/
				ʱCMD12ָֹƬѡ8ʱӽա
				
3	д飺	CMD24ָȴSDӦ0xfeһݣ51220xffCRCȴӦֹƬѡ8ʱӽ

4	д飺	CMD55ACMD23SDУCMD250xfcдһݿ飬0xffCRC
				ȴMISOߣ0xfcдһݿ飬0xffCRC0xfdƣдһݿ飬д롣ֹƬѡ8ʱӽд롣

****************************************************************************************************
	CMD0		λSD	ӦR1
	CMD1		ʼSD ӦR1MMCʹãʹʼ

	CMD8		ͽӿ״̬VHS+Check patternӦR7VHS緶ΧCheck patternͨѶ2.0,1.0
				һ VHS = 0x1AA2.7~3.6V 2.0ԺĿָָ֧
				
	CMD9		ضĴ SCRӦR1
	CMD10:		־ݼĴ CIDӦR1
	
	CMD12		Ӧ
	CMD16		ÿСSDHC-2TС̶Ϊ512ֽڣ:С
	CMD17		1 ַSDHCַĵλ512ֽΪλ
	CMD18		飬ַ
	CMD24		д飬ַ
	CMD25		д飬ַ
	CMD55		֪ͨSD͵ӦָAPP_CMD
	CMD58		OCRĴ,ӦR330λCCSCCS=1ΪSDHC CCS = 0ΪSDSC
	
	ACMD23	Ԥݿ飬дٶ
	ACMD41	͸֧Ϣͼʼ̣spiӦR1SDģʽӦR3
	
	
*********************************************************************************************************
	ӦR1~R7

	R1Ӧ	λ7ʼλʼΪ065ַ4ϵд3CRC2Ƿָ
				1λ0æ״̬  Ϊ1ΪЧ0ΪЧ
*********************************************************************************************************				
ע⣺
		ʼʱʱܳ400KHZ2.5us
	
*/


sbit SD_CS = P1^0;
sbit SD_SCL = P1^1;
sbit SD_SI = P1^2;
sbit SD_SO = P1^3;

#define DELAY_TIME 10	//SDλʼʱʹʱ
#define TRY_TIME 200 //SDдݣĴ

#define SD_CS_DISABLE() SD_CS = 1
#define SD_CS_ENABLE()  SD_CS = 0

/* SDݽǷͷߺ궨 */
#define NO_RELEASE      0
#define RELEASE         1	//ͷ

//붨

#define INIT_CMD0_ERROR 	0X01//CMD0
#define INIT_CMD1_ERROR 	0X02//CMD1
#define WRITE_BLOCK_ERROR 	0X03//д
#define READ_BLOCK_ERROR 	0X04//

/* SDָ */
#define CMD0    0      //λ  (ӦʽR1)
#define CMD1    1      //MMCʼʼ
#define CMD8	8      //ʶ𿨵İ汾
#define CMD9    9      //9 CSD   (ӦʽR1)
#define CMD10   10     //10CID   (ӦʽR1)
#define CMD12   12     //12ֹͣݴ    (ӦʽR1b)
#define CMD16   16     //16SectorSize Ӧ0x00   (ӦʽR1)
#define CMD17   17     //17sector    (ӦʽR1)
#define CMD18   18     //18Multi sector    (ӦʽR1)
#define ACMD23  23     //23ösectorдǰԤȲNblock    (ӦʽR1)
#define CMD24   24     //24дsector    (ӦʽR1)
#define CMD25   25     //25дMulti sector    (ӦʽR1)
#define ACMD41  41     //41Ӧ0x00    (ӦʽR1)
#define CMD55   55     //55Ӧ0x01    (ӦʽR1)
#define CMD58   58     //58OCRϢ     (ӦʽR1)
#define CMD59   59     //59ʹ/ֹCRCӦ0x00    (ӦʽR1)

/* SDͶ */
#define SD_TYPE_MMC       10
#define SD_TYPE_V1        11
#define SD_TYPE_V2SDSC    12
#define SD_TYPE_V2SDHC    14

//

unsigned char SD_Init();//ʼSD汾

//unsigned char SD_GetCID(unsigned char *cid_data);//ȡSDCIDϢϢ
//unsigned char SD_GetCSD(unsigned char *csd_data);//ȡSDCSDϢٶϢ
//unsigned long int SD_GetCapacity(void);//ȡSDֽڣ
unsigned char SD_ReadSingleBlock(unsigned long int sector, unsigned char *buffer);//SDһblock
unsigned char SD_WriteSingleBlock(unsigned long int sector, const unsigned char *buffer);//дSDһblock
//unsigned char SD_ReadMultiBlock(unsigned long int sector, unsigned char *buffer, unsigned char count);//SDĶblock
//unsigned char SD_WriteMultiBlock(unsigned long int sector, const unsigned char *dat, unsigned char count);
//unsigned char SD_Read_Bytes(unsigned long address,unsigned char *buf,unsigned int offset,unsigned int bytes);//ָ,offsetʼbytesֽ
//unsigned char SD_WaitReady(void)
#endif