#include "sdspi.h"
//#include "uart.h"
bit is_init = 0;//ΪSDʼ׼
unsigned char SD_Type = 0;
/*******************************************************
*-	
*-	ʱ
*-		
*-ֵ	
*-ע		
*******************************************************/

void delay(unsigned int dat)
{
	while(dat--);
}

/*******************************************************
*-	
*-	SDдһֽ
*-		
*-ֵ	redat 
*-ע		
*******************************************************/
unsigned char SD_spi_RW(unsigned char sedat)
{
	
	unsigned char redat=0,i;
	SD_SO = 1;
	SD_SCL = 1;
	for(i=0;i<8;i++)
	{
		SD_SI = sedat&0x80;
		sedat = sedat<<1;
		if(is_init) delay(DELAY_TIME);
		SD_SCL = 0;
		redat = redat<<1;
		if(is_init) delay(DELAY_TIME);
		redat |= SD_SO;
		SD_SCL = 1;
	}
	return redat;
}


/*******************************************************
*-	
*-	ָ
*-		cmd,argument crc У
*-ֵ	
*-ע		
*******************************************************/

unsigned char SD_SendCmd(unsigned char cmd,unsigned long int argument,unsigned char crc)
{
	unsigned char temp;
	unsigned int Retry=0;
	SD_CS = 1;
	SD_spi_RW(0xff);//߼ԣûЩSD֧ܲ
	
	SD_CS = 0;
	SD_spi_RW(0x40|cmd);
	SD_spi_RW((unsigned char)((argument>>24)));
	SD_spi_RW((unsigned char)(argument>>16));
	SD_spi_RW((unsigned char)(argument>>8));
	SD_spi_RW((unsigned char)argument);
	SD_spi_RW(crc);
	
   //ȴӦʱ˳
   while((temp = SD_spi_RW(0xFF))==0xFF)
   {
	 Retry++;
	 if(Retry > TRY_TIME)break; //ʵãԴ  
   }
   
   SD_CS = 1;
   SD_spi_RW(0xff);
  //Ӧֵ
  return temp;
}

/*******************************************************************************
* Function Name  : SD_SendCmd_NoDeassert
* Description    : SDһ(ǲʧƬѡкݴ
* Input          : unsigned char cmd    
*                  unsigned long int arg  
*                  unsigned char crc   crcУֵ
* Output         : None
* Return         : unsigned char r1 SDصӦ
*******************************************************************************/
unsigned char SD_SendCmdNoDeassert(unsigned char cmd,unsigned long int argument,unsigned char crc)
{
	unsigned char temp;
	unsigned int Retry=0;
	SD_CS = 1;
	SD_spi_RW(0xff);//߼ԣûЩSD֧ܲ
	
	SD_CS = 0;
	SD_spi_RW(0x40|cmd);
	SD_spi_RW((unsigned char)((argument>>24)));
	SD_spi_RW((unsigned char)(argument>>16));
	SD_spi_RW((unsigned char)(argument>>8));
	SD_spi_RW((unsigned char)argument);
	SD_spi_RW(crc);
	
   //ȴӦʱ˳
   while((temp = SD_spi_RW(0xFF))==0xFF)
   {
	 Retry++;
	 if(Retry > TRY_TIME)break; //ʵãԴ  
   }
  //Ӧֵ
  return temp;
}
/*******************************************************
*-	
*-	λSD
*-		
*-ֵ	
*-ע		
*******************************************************/

unsigned char SD_Reset()
{
	unsigned char time ,temp,i;
	//unsigned char pcmd[] = {0x40,0x00,0x00,0x00,0x00,0x95};//COMD0ָ
	
	is_init=1;
	
	SD_CS = 1;//رƬѡ
	
	for(i=0;i<0x0f;i++)
	{
		SD_spi_RW(0xff);//120ʱ
	}
	
	SD_CS = 0;//Ƭѡ
	
	time = 0;
	do
	{
		//temp = SD_Write_Cmd(pcmd);
		temp = SD_SendCmd(CMD0,0,0X95);
		time++;
		if(time >=TRY_TIME)
		{
			SD_CS = 1;//رƬѡ
			return (temp);
			
		}
	}while(temp != 0x01);
	SD_CS = 1;//رƬѡ
	SD_spi_RW(0xff);//8ʱ
	return temp;
}


/*******************************************************
*-	
*-		//-----------------SDMMCʼʼ-----------------	 
				//ʼָCMD55+ACMD41
				// Ӧ˵SDҳʼ
				// ûлӦ˵MMCӦʼ
*-		
*-ֵ	
*-ע		
*******************************************************/

//жMMC
//unsigned char MMC_Init()
//{
//	unsigned char r1;
//	unsigned int retry = 0;
//	//MMCʼûвԣ
//	do
//	{
//	   r1 = SD_SendCmd(CMD1, 0, 0);
//	   retry++;
//	}while((r1!=0x00)&& (retry<400));
//	if(retry>=400)return 1;   //MMCʼʱ		    
//	//д뿨
//	SD_Type = SD_TYPE_MMC;
//	return SD_Type;
//}


//V1.0汾жSDMMC
//unsigned char SD_MMC_Init()
//{
//	 unsigned char r1;
//	 unsigned int retry = 0;
//	
//     do
//     {
//       //ȷCMD55Ӧ0x01
//       r1 = SD_SendCmd(CMD55, 0, 0);
//       if(r1 != 0x01)
//         return r1;	  
//       //õȷӦ󣬷ACMD41Ӧõֵ0x00400
//       r1 = SD_SendCmd(ACMD41, 0, 0);
//       retry++;
//     }while((r1!=0x00) && (retry<400));
//     // жǳʱǵõȷӦ
//     // лӦSDûлӦMMC
//	 SD_Type = SD_TYPE_V1;
//	 if(retry >= 400) SD_Type = MMC_Init();
//	 return SD_Type;
//}


//жV2.0ͺ
unsigned char SDV2_Init()
{
	unsigned int retry;
	unsigned char r1;
	unsigned char buff = 0;
    //V2.0ĿCMD8ᴫ4ֽڵݣҪٽ
//	   buff[0] = SD_spi_RW(0xFF);  //should be 0x00
//	   buff[1] = SD_spi_RW(0xFF);  //should be 0x00
//	   buff[2] = SD_spi_RW(0xFF);  //should be 0x01
//	   buff[3] = SD_spi_RW(0xFF);  //should be 0xAA	   
		SD_spi_RW(0xFF);
		SD_spi_RW(0xFF);
		SD_spi_RW(0xFF);
		SD_spi_RW(0xFF);
//	UART1_SendOneChar(0x55);
//	UART1_SendOneChar(buff[0]); 
//	UART1_SendOneChar(buff[1]); 
//	UART1_SendOneChar(buff[2]); 
//	UART1_SendOneChar(buff[3]); 	
    SD_CS = 1;	  
    SD_spi_RW(0xFF);//the next 8 clocks			 
    //жϸÿǷ֧2.7V-3.6VĵѹΧ
    //if(buff[2]==0x01 && buff[3]==0xAA) //粻жϣֵ֧Ŀ
   // {	  
       retry = 0;
       //ʼָCMD55+ACMD41
       do
       {
    	  r1 = SD_SendCmd(CMD55, 0, 0);
    	  if(r1!=0x01)return r1;	   
    	  r1 = SD_SendCmd(ACMD41, 0x40000000, 1);
          if(retry>200)return r1;  //ʱ򷵻r1״̬  
       }while(r1!=0);		  
       //ʼָɣȡOCRϢ	
	   
       //-----------SD2.0汾ʼ-----------
       r1 = SD_SendCmdNoDeassert(CMD58, 0, 0);
	   
       if(r1!=0x00)return r1;  //ûзȷӦֱ˳Ӧ		 
       //OCRָ󣬽4ֽڵOCRϢ
       buff = SD_spi_RW(0xFF);
//       buff[1] = SD_spi_RW(0xFF); 
//       buff[2] = SD_spi_RW(0xFF);
//       buff[3] = SD_spi_RW(0xFF);
	   SD_spi_RW(0xFF);
	   SD_spi_RW(0xFF);
	   SD_spi_RW(0xFF);
//		UART1_SendOneChar(0x56);
//		UART1_SendOneChar(buff[0]); 
//		UART1_SendOneChar(buff[1]); 
//		UART1_SendOneChar(buff[2]); 
//		UART1_SendOneChar(buff[3]); 	
       //OCRɣƬѡø
       SD_CS = 1;
       SD_spi_RW(0xFF);

       //յOCRеbit30λCCSȷΪSD2.0SDHC
       //CCS=1SDHC   CCS=0SD2.0
       if(buff&0x40)SD_Type = SD_TYPE_V2SDHC;    //CCS	 
       else SD_Type = SD_TYPE_V2SDSC;	    
       //-----------SD2.0汾----------- 
       //SPIΪģʽ
       is_init=0; 
		return 0;
   // }	    
}

/*******************************************************
*-	
*-	ʼ
*-		
*-ֵ	temp Ϊ0˵ɹ
*-ע		
*******************************************************/

unsigned char SD_Init()
{
	unsigned char temp;
	temp = SD_Reset();//дCMD0λ
	//UART1_SendStr("λ"); 
//	UART1_SendOneChar(temp);
	
	temp = SD_SendCmdNoDeassert(CMD8,0X1AA,0X87);
	
 //Ƭ汾Ϣv1.0汾ģtemp=0x05³ʼ
	if(temp==0x05)
	{
		//ÿΪSDV1.0⵽ΪMMC޸ΪMMC
		 //SD_Type = SD_TYPE_V1;	   
		 //V1.0CMD8ָûк
		 //Ƭѡøߣ
//		 SD_CS = 1;
//		 //෢8CLKSD
//		 SD_spi_RW(0xFF);	
//		 SD_Type = SD_MMC_Init();
//		 is_init=0;
//		 SD_spi_RW(0xFF);
//		
//		 //ֹCRCУ	   
//		 temp = SD_SendCmd(CMD59, 0, 0x95);
//		 if(temp != 0x00)return temp;  //󣬷r1   	   
//		 //Sector Size
//		 temp = SD_SendCmd(CMD16, 512, 0x95);
//		 if(temp != 0x00)return temp;//󣬷r1	
	}
  //V2.0ĳʼ
  //ҪȡOCRݣжSD2.0SD2.0HC
	else if(temp == 0x01)
	  {
		 temp = SDV2_Init();
	  }
	// UART1_SendOneChar(temp);
    return temp;
}


/*******************************************************************************
* Function Name  : SD_ReceiveData
* Description    : SDжָȵݣڸλ
* Input          : unsigned char *dat(Ŷݵڴ>len)
*                  unsigned int len(ݳȣ
*                  unsigned char release(ɺǷͷCSø 0ͷ 1ͷţ
* Output         : None
* Return         : unsigned char 
*                  0NO_ERR
*                  otherϢ
*******************************************************************************/
unsigned char SD_ReceiveData(unsigned char *dat, unsigned int len, unsigned char release)
{
  unsigned int retry;
  unsigned char r1;
  // һδ
  SD_CS_ENABLE();
  //ȴSDʼ0xFE
  retry = 0;										   
  do
  {
    r1 = SD_spi_RW(0xFF);
    retry++;
    if(retry>4000)  //4000εȴûӦ˳(ʵԣ˴öԼ
    {
      SD_CS_DISABLE();
        return 1;
    }
    }while(r1 != 0xFE);
		   
    //ʼ
    while(len--)
    {
      *dat = SD_spi_RW(0xFF);
      dat++;
    }
    //2αCRCdummy CRC
    SD_spi_RW(0xFF);
    SD_spi_RW(0xFF);
    //ͷߣCSø
    if(release == RELEASE)
    {
      //
      SD_CS_DISABLE();
      SD_spi_RW(0xFF);
    }											  					    
    return 0;
}


/*******************************************************************************
* Function Name  : SD_GetCID
* Description    : ȡSDCIDϢϢ
* Input          : unsigned char *cid_data(CIDڴ棬16Byte
* Output         : None
* Return         : unsigned char 
*                  0NO_ERR
*                  1TIME_OUT
*                  otherϢ
*******************************************************************************/
//unsigned char SD_GetCID(unsigned char *cid_data)
//{
//  unsigned char r1;

//  //CMD10CID
//  r1 = SD_SendCmd(CMD10, 0, 0xFF);
//  if(r1 != 0x00)return r1;  //ûȷӦ˳    
//  //16ֽڵ
//  SD_ReceiveData(cid_data, 16, RELEASE);	 
//  return 0;
//}

/*******************************************************************************
* Function Name  : SD_GetCSD
* Description    : ȡSDCSDϢٶϢ
* Input          : unsigned char *cid_data(CIDڴ棬16Byte
* Output         : None
* Return         : unsigned char 
*                  0NO_ERR
*                  1TIME_OUT
*                  otherϢ
*******************************************************************************/
//unsigned char SD_GetCSD(unsigned char *csd_data)
//{
//  unsigned char r1;

//  //CMD9CSD
//  r1 = SD_SendCmd(CMD9, 0, 0xFF);
//  if(r1 != 0x00)return r1;  //ûȷӦ˳  
//  //16ֽڵ
//  SD_ReceiveData(csd_data, 16, RELEASE);

//  return 0;
//}
/*******************************************************************************
* Function Name  : SD_GetCapacity
* Description    : ȡSDֽڣ
* Input          : None
* Output         : None
* Return         : unsigned long int capacity 
*                   0 ȡ 
*******************************************************************************/
//unsigned long int SD_GetCapacity(void)
//{
//  unsigned char csd[16];
//  unsigned long int Capacity;
//  unsigned char r1;
//  unsigned int i;
//  unsigned int temp;

//  //ȡCSDϢڼ0
//  if(SD_GetCSD(csd)!=0) return 0;	    
//  //ΪSDHC淽ʽ
//  if((csd[0]&0xC0)==0x40)
//  {									  
//    Capacity=((unsigned long int)csd[8])<<8;
//    Capacity+=(unsigned long int)csd[9]+1;	 
//    Capacity = (Capacity)*1024;//õ
//    Capacity*=512;//õֽ			   
//  }
//  else
//  {		    
//    i = csd[6]&0x03;
//    i<<=8;
//    i += csd[7];
//    i<<=2;
//    i += ((csd[8]&0xc0)>>6);
//    
//    //C_SIZE_MULT
//    r1 = csd[9]&0x03;
//    r1<<=1;
//    r1 += ((csd[10]&0x80)>>7);	 
//    r1+=2;//BLOCKNR
//    temp = 1;
//    while(r1)
//    {
//      temp*=2;
//      r1--;
//    }
//    Capacity = ((unsigned long int)(i+1))*((unsigned long int)temp);	 
//    // READ_BL_LEN
//    i = csd[5]&0x0f;
//    //BLOCK_LEN
//    temp = 1;
//    while(i)
//    {
//      temp*=2;
//      i--;
//    }
//    //The final result
//    Capacity *= (unsigned long int)temp;//ֽΪλ 	  
//  }
//  return (unsigned long int)Capacity;
//}

/*******************************************************************************
* Function Name  : SD_WaitReady
* Description    : ȴSDReady
* Input          : None
* Output         : None
* Return         : u8 
*                   0 ɹ
*                   otherʧ
*******************************************************************************/
//unsigned char SD_WaitReady(void)
//{
//  unsigned char r1;
//  unsigned int retry=0;
//  do
//  {
//    r1 = SD_spi_RW(0xFF);
//    retry++;
//    if(retry==0xfffe)
//      return 1; 
//  }while(r1!=0xFF); 
//    return 0;
//}	 
/*******************************************************************************
* Function Name  : SD_ReadSingleBlock
* Description    : SDһblock
* Input          : unsigned long int sector ȡַsectorֵַ 
*                  unsigned char *buffer ݴ洢ַС512byte 
* Output         : None
* Return         : unsigned char r1 
*                   0 ɹ
*                   otherʧ
*******************************************************************************/
unsigned char SD_ReadSingleBlock(unsigned long int sector, unsigned char *buffer)
{
  unsigned char r1;
  //Ϊģʽ
  is_init=0;

 if(SD_Type!=SD_TYPE_V2SDHC)
  {
	 //SDHCsectorַתbyteַ
     sector = sector<<9;//512*sectorıַ߽
  }
    
  r1 = SD_SendCmd(CMD17, sector, 1);//
												    
  if(r1 != 0x00)return r1; 		   							  
  r1 = SD_ReceiveData(buffer, 512, RELEASE);		 
  if(r1 != 0)
    return r1;   //ݳ
  else 
    return 0; 
}

/*******************************************************************************
* Function Name  : SD_WriteSingleBlock
* Description    : дSDһblock
* Input          : unsigned long int sector ַsectorֵַ 
*                  unsigned char *buffer ݴ洢ַС512byte 
* Output         : None
* Return         : unsigned char r1 
*                   0 ɹ
*                   otherʧ
*******************************************************************************/
unsigned char SD_WriteSingleBlock(unsigned long int sector, const unsigned char *buffer)
{
  unsigned char r1;
  unsigned int i;
  unsigned int retry;

  //Ϊģʽ
  is_init=0;

  //SDHCsectorַתbyteַ
  if(SD_Type!=SD_TYPE_V2SDHC)
  {
     sector = sector<<9;//512*sectorıַ߽
  }

  r1 = SD_SendCmd(CMD24, sector, 0x00);
  if(r1 != 0x00)
  {
    return r1;  //Ӧȷֱӷ
  }
    
  //ʼ׼ݴ
  SD_CS_ENABLE();
  //ȷ3ݣȴSD׼
  SD_spi_RW(0xff);
  SD_spi_RW(0xff);
  SD_spi_RW(0xff);
  //ʼ0xFE
  SD_spi_RW(0xFE);

  //һsector
  for(i=0;i<512;i++)
  {
     SD_spi_RW(*buffer++);
  }
  //2Bytedummy CRC
  SD_spi_RW(0xff);
  SD_spi_RW(0xff);
    
  //ȴSDӦ
  r1 = SD_spi_RW(0xff);
  if((r1&0x1F)!=0x05)
  {
     SD_CS_DISABLE();
     return r1;
  }
    
  //ȴ
  retry = 0;
  while(!SD_spi_RW(0xff))//Աʱ߱
  {
     retry++;
     if(retry>65534)        //ʱдûɣ˳
     {
        SD_CS_DISABLE();
        return 1;           //д볬ʱ1
     }
  }

  //дɣƬѡ1
  SD_CS_DISABLE();
  SD_spi_RW(0xff);

  return 0;
}

/*******************************************************************************
* Function Name  : SD_ReadMultiBlock
* Description    : SDĶblock
* Input          : unsigned long int sector ȡַsectorֵַ 
*                  unsigned char *buffer ݴ洢ַС512byte
*                  unsigned char count countblock
* Output         : None
* Return         : unsigned char r1 
*                   0 ɹ
*                   otherʧ
*******************************************************************************/
//unsigned char SD_ReadMultiBlock(unsigned long int sector, unsigned char *buffer, unsigned char count)
//{
//  unsigned char r1;	 			 
//  is_init=1;//Ϊģʽ 
//  
//  if(SD_Type != SD_TYPE_V2SDHC)
//    sector = sector<<9;//SDHCsectorַתbyteַ   
// // sector = sector<<9;//SDHCsectorַתbyteַ
// //SD_WaitReady();
// //
//  r1 = SD_SendCmd(CMD18, sector, 1);//
//  if(r1 != 0x00)return r1;	 
//  do//ʼ
//  {
//    if(SD_ReceiveData(buffer, 512, NO_RELEASE) != 0x00)
//    {
//       break;
//    }
//    buffer += 512;
//  } while(--count);		 
//  //ȫϣֹͣ
//  SD_SendCmd(CMD12, 0, 1);
//  //ͷ
//  SD_CS_DISABLE();
//  SD_spi_RW(0xFF);    
//  if(count != 0)
//    return count;   //ûд꣬ʣ	 
//  else 
//    return 0;	 
//}

/*******************************************************************************
* Function Name  : SD_WriteMultiBlock
* Description    : дSDNblock
* Input          : unsigned long int sector ַsectorֵַ 
*                  unsigned char *buffer ݴ洢ַС512byte
*                  unsigned char count дblockĿ
* Output         : None
* Return         : unsigned char r1 
*                   0 ɹ
*                   otherʧ
*******************************************************************************/
//unsigned char SD_WriteMultiBlock(unsigned long int sector, const unsigned char *dat, unsigned char count)
//{
//  unsigned char r1;
//  unsigned int i;	 		 
//  is_init=1;//Ϊģʽ	 
//  if(SD_Type != SD_TYPE_V2SDHC)
//    sector = sector<<9;//SDHCsectorַתbyteַ  
//  if(SD_Type != SD_TYPE_MMC) 
//    r1 = SD_SendCmd(ACMD23, count, 0x01);//Ŀ꿨MMCACMD23ָʹԤ   
//  r1 = SD_SendCmd(CMD25, sector, 0x01);//дָ
//  if(r1 != 0x00)return r1;  //Ӧȷֱӷ	 
//  SD_CS_ENABLE();//ʼ׼ݴ   
//  SD_spi_RW(0xff);//ȷ3ݣȴSD׼
//  SD_spi_RW(0xff);   
//  //--------Nsectorдѭ
//  do
//  {
//    //ʼ0xFC Ƕд
//     SD_spi_RW(0xFC);	  
//     //һsector
//     for(i=0;i<512;i++)
//     {
//        SD_spi_RW(*dat++);
//     }
//     //2Bytedummy CRC
//     SD_spi_RW(0xff);
//     SD_spi_RW(0xff);
//        
//     //ȴSDӦ
//     r1 = SD_spi_RW(0xff);
//     if((r1&0x1F)!=0x05)
//     {
//        SD_CS_DISABLE();    //ӦΪֱ˳
//        return r1;
//     }

//     //ȴSDд
//     if(SD_WaitReady()==1)
//     {
//        SD_CS_DISABLE();    //ȴSDдɳʱֱ˳
//        return 1;
//     }	   
//    }while(--count);//sectorݴ
//    
//    //0xFD
//    r1 = SD_spi_RW(0xFD);
//    if(r1==0x00)
//    {
//       count =  0xfe;
//    }		   
//    if(SD_WaitReady()) //ȴ׼
//    {
//      SD_CS_DISABLE();
//      return 1;  
//    }
//    //дɣƬѡ1
//    SD_CS_DISABLE();
//    SD_spi_RW(0xff);  
//    return count;   //countֵдcount=0count=1
//}
	
/*******************************************************************************
* Function Name  : SD_Read_Bytes
* Description    : ָ,offsetʼbytesֽ
* Input          : unsigned long int address ַsectorֵַ 
*                  unsigned char *buf     ݴ洢ַС<=512byte
*                  unsigned int offset  ƫ
                   unsigned int bytes   Ҫֽ
* Output         : None
* Return         : unsigned char r1 
*                   0 ɹ
*                   otherʧ
*******************************************************************************/
//unsigned char SD_Read_Bytes(unsigned long address,unsigned char *buf,unsigned int offset,unsigned int bytes)
//{
//  unsigned char r1;unsigned int i=0;  
//  r1=SD_SendCmd(CMD17,address<<9,1);//Ͷ      
//  if(r1!=0x00)return r1;  //Ӧȷֱӷ
//  SD_CS_ENABLE();//ѡSD
//  while (SD_spi_RW(0xff)!= 0xFE)//ֱȡݵĿʼͷ0XFEż
//  {
//    i++;
//    if(i>3000)
//    {
//      SD_CS_DISABLE();//رSD
//      return 1;//ȡʧ
//    }
//  }; 		 
//  for(i=0;i<offset;i++)
//    SD_spi_RW(0xff);//offsetλ 
//  for(;i<offset+bytes;i++)
//    *buf++=SD_spi_RW(0xff);//ȡ	
//  for(;i<512;i++) 
//	SD_spi_RW(0xff); 	 //ʣֽ
//  SD_spi_RW(0xff);//αCRC
//  SD_spi_RW(0xff);  
//  SD_CS_DISABLE();//رSD
//  return 0;
//}

